Attribute VB_Name = "Worker"
'  FILE:       Worker.bas
'              Microsoft TPC-H Kit Ver. 2.7.0-1005
'              Copyright Microsoft, 2008
'              All Rights Reserved
'
'
'  PURPOSE:    Contains some high-level functions to add and modify
'              worker steps. Most of the actual maintenance of
'              steps is done by the Step modules.
'  Contact:    Reshma Tharamal (reshmat@microsoft.com)
'
Option Explicit

Private mcQueryStep As New cStep
Private mcQueryWorker As New cWorker

' Used to indicate the source module name when errors
' are raised by this module
Private Const mstrModuleName As String = "Worker."

Sub ShowModifyWorkerStepForm(Optional ByVal lngIdentifier As Long = 0)
    ' Displays the modify worker step form to the user

    Dim lngStepId As Long
    
    On Error GoTo ShowModifyWorkerStepFormErr

    Set mcQueryStep = mcQueryWorker
    
    Set mcQueryStep = ProcessStepModify(lngIdentifier)
    
    Call ShowStepForm
    
    Exit Sub
    
ShowModifyWorkerStepFormErr:
    ' Log the error code raised by Visual Basic
    Call LogErrors(Errors)
    gstrSource = mstrModuleName & "ShowModifyWorkerStepForm"
    On Error GoTo 0
    Err.Raise vbObjectError + errProcessStepModifyFailed, _
            gstrSource, _
            LoadResString(errProcessStepModifyFailed)
    
End Sub
Sub WorkerModify()

    ' Call a common procedure to carry out the step update
    Call StepModify(mcQueryStep, gintWorkerStep)
    
End Sub
Public Sub WorkerNew()

    Dim cNewStep As cStep
    Dim cNewWorkerStep As cWorker
    
    On Error GoTo WorkerNewErr

    Set cNewWorkerStep = New cWorker
    
    ' Some properties of a step are not applicable to Worker steps.
    ' Those properties will be set to empty strings or zero, as
    ' applicable, by the Worker step class when an instance is created
    ' The Let functions will also set the values to empty strings or zero,
    ' as applicable, and ignore any passed in values
    Set cNewStep = cNewWorkerStep
    Call PopulatePositionDtls(cCreateStep, cNewStep)
    
    ' Call a common procedure that will handle inserts for all steps
    Call StepNew(cNewStep, gintWorkerStep)
    
    ' If we created the step due to an Apply then the subsequent OK should update
    ' the step
    Set mcQueryStep = cNewStep
    
    Set cNewStep = Nothing
    Set cNewWorkerStep = Nothing
    Set cCreateStep = Nothing
    
    Exit Sub
    
WorkerNewErr:
    ' Log the error code raised by Visual Basic
    Call LogErrors(Errors)
    gstrSource = mstrModuleName & "WorkerNew"
    On Error GoTo 0
    Err.Raise vbObjectError + errNewStepFailed, _
            gstrSource, _
            LoadResString(errNewStepFailed)
    
End Sub
