VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cRunItDetails"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'  FILE:        cRunItDetails.cls
'               Microsoft TPC-H Kit Ver. 2.7.0-1005
'               Copyright Microsoft, 2008
'               All Rights Reserved
'
'
'  PURPOSE:     This module encapsulates the properties of iterator values
'               that are used by the step being executed at runtime.
'  Contact:     Reshma Tharamal (reshmat@microsoft.com)
'

Option Explicit

' Used to indicate the source module name when errors
' are raised by this class
Private Const mstrModuleName As String = "cRunItDetails."
Private mstrSource As String

Private mstrIteratorName As String
Private mintType As ValueType
Private mlngSequence As Long
Private mlngFrom As Long
Private mlngTo As Long
Private mlngStep As Long
Private mstrValue As String

Public Property Get RangeTo() As Long

    RangeTo = mlngTo
    
End Property
Public Property Let RangeTo(ByVal vdata As Long)
    
    mlngTo = vdata

End Property

Public Property Get RangeFrom() As Long

    RangeFrom = mlngFrom
    
End Property
Public Property Get Sequence() As Long

    Sequence = mlngSequence
    
End Property

Public Property Get RangeStep() As Long

    RangeStep = mlngStep
    
End Property
Public Property Let RangeStep(vdata As Long)

    mlngStep = vdata
    
End Property

Public Property Let RangeFrom(ByVal vdata As Long)
    
    mlngFrom = vdata

End Property
Public Property Let Sequence(ByVal vdata As Long)
    
    mlngSequence = vdata

End Property

Public Property Get IteratorType() As ValueType
    
    IteratorType = mintType
        
End Property
Public Property Let IteratorType(ByVal vdata As ValueType)
    
    On Error GoTo TypeErr
    mstrSource = mstrModuleName & "Type"
    
    ' These constants have been defined in the enumeration,
    ' Type, which is exposed
    Select Case vdata
        Case gintFrom, gintTo, gintStep, gintValue
            mintType = vdata
        
        Case Else
            On Error GoTo 0
            Err.Raise vbObjectError + errTypeInvalid, _
                mstrSource, LoadResString(errTypeInvalid)
    End Select
    
    Exit Property
    
TypeErr:
    LogErrors Errors
    mstrSource = mstrModuleName & "Type"
    On Error GoTo 0
    Err.Raise vbObjectError + errTypeInvalid, _
        mstrSource, LoadResString(errTypeInvalid)

End Property
Private Sub IsList()

    If mintType <> gintValue Then
        On Error GoTo 0
        Err.Raise vbObjectError + errInvalidProperty, mstrSource, _
                LoadResString(errInvalidProperty)
    End If
    
End Sub
Private Sub IsRange()

    If mintType = gintValue Then
        On Error GoTo 0
        Err.Raise vbObjectError + errInvalidProperty, mstrSource, _
                LoadResString(errInvalidProperty)
    End If
    
End Sub

Public Property Get Value() As String

    Value = mstrValue
    
End Property
Public Property Let Value(vdata As String)

    mstrValue = vdata
    
End Property


Public Property Get IteratorName() As String

    IteratorName = mstrIteratorName
    
End Property
Public Property Let IteratorName(ByVal vdata As String)
    
    mstrIteratorName = vdata

End Property

